package logger

import (
	"fmt"
)

func GetContextLogger() Logger {
	return logger
}

// func ClearInfo() {
// 	InitLogs(nil, nil)
// }

// func InitLogs(requestID *string, request *events.APIGatewayProxyRequest) {
// 	logger = Logger{
// 		currentRequestID: requestID,
// 		apiRequest:       request,
// 		level:            LevelInfo,
// 		writer:           os.Stderr,
// 		data: map[string]interface{}{
// 			"environment": getEnvironment(),
// 		},
// 	}
// 	if requestID != nil {
// 		logger.data["request_id"] = *requestID
// 	}

// 	if val, exists := os.LookupEnv("DEBUGGING"); exists && strings.ToLower(val) == "true" {
// 		logger.level = LevelDebug
// 	}
// }

// func getEnvironment() string {
// 	environment := os.Getenv("ENVIRONMENT")
// 	if environment == "" {
// 		environment = "prod"
// 	}
// 	return environment
// }

func LogMessageWithFields(fields map[string]interface{}, message interface{}) {
	logger.WithFields(fields).log(LevelInfo, 1, fmt.Sprintf("%v", message))
}

func LogMessage(format string, a ...interface{}) {
	logger.log(LevelInfo, 1, fmt.Sprintf(format, a...))
}

func LogError(fields map[string]interface{}, err error) {
	// sendRaygunError(fields, err)
	logger.WithFields(fields).log(LevelError, 1, fmt.Sprintf("%+v", err))
}

func LogErrorMessage(message interface{}, err error) {
	if err != nil || message != nil {
		logger.WithFields(map[string]interface{}{
			"error": fmt.Sprintf("%+v", err),
		}).log(LevelError, 1, fmt.Sprintf("%v", message))
	}
}

func LogWarningMessage(format string, a ...interface{}) {
	logger.log(LevelWarn, 1, fmt.Sprintf(format, a...))
}

func LogWarning(fields map[string]interface{}, err error) {
	logger.WithFields(fields).log(LevelWarn, 1, fmt.Sprintf("%+v", err))
}

func SQLDebugInfo(sql string) {
	logger.WithFields(map[string]interface{}{
		"sql": sql,
	}).log(LevelInfo, 1, "SQL")
}

// func LogRequestInfo(req events.APIGatewayProxyRequest) {
// 	fields := map[string]interface{}{
// 		"http_method":                req.HTTPMethod,
// 		"path":                       req.Path,
// 		"api_gateway_request_id":     req.RequestContext.RequestID,
// 		"user_cognito_auth_provider": req.RequestContext.Identity.CognitoAuthenticationProvider,
// 		"user_arn":                   req.RequestContext.Identity.UserArn,
// 	}
// 	logger.WithFields(fields).log(LevelInfo, 1, "Request Info start")
// }

// func LogSQSEvent(event events.SQSEvent) {
// 	logger.WithFields(map[string]interface{}{
// 		"records": event.Records,
// 	}).log(LevelInfo, 1, "SQS event start")
// }
