package logger

import (
	"context"
	"os"

	"github.com/go-pg/pg/v10"
)

type DbLogger struct{}

func (d DbLogger) BeforeQuery(c context.Context, q *pg.QueryEvent) (context.Context, error) {
	return c, nil
}

func (d DbLogger) AfterQuery(c context.Context, q *pg.QueryEvent) error {
	sql, _ := q.FormattedQuery()
	if os.Getenv("DEBUGGING") == "true" {
		Debugf(string(sql))
	} else {
		SQLDebugInfo(string(sql))
	}
	return nil
}
