package logger

import "fmt"

type Level int

func (level Level) String() string {
	switch level {
	case LevelFatal:
		return "fatal"
	case LevelError:
		return "error"
	case LevelWarn:
		return "warn"
	case LevelInfo:
		return "info"
	case LevelDebug:
		return "debug"
	}
	return fmt.Sprintf("Level(%d)", level)
}

func (level Level) MarshalJSON() ([]byte, error) {
	return []byte("\"" + level.String() + "\""), nil
}

const (
	LevelFatal Level = iota
	LevelError
	LevelWarn
	LevelInfo
	LevelDebug
)
