package logger_test

import (
	"os"
	"testing"

	"gitlab.com/uafrica/go-utils/errors"
	"gitlab.com/uafrica/go-utils/logger"
)

func TestLogs(t *testing.T) {
	//requestID := t.Name()
	//event := events.APIGatewayProxyRequest{}
	os.Setenv("DEBUGGING", "true")
	//logger.InitLogs(&requestID, &event)

	// formatter := log.TextFormatter{}
	// log.SetFormatter(&formatter)

	logger.LogMessageWithFields(map[string]interface{}{"a": 1, "b": 2}, "MyLogMessage1")
	logger.LogMessage("MyLogMessage2=%d,%d,%d", 1, 2, 3)
	logger.LogError(map[string]interface{}{"a": 4, "b": 5}, errors.Errorf("simple mistake"))
	logger.LogErrorMessage("Error Message", errors.Errorf("another simple mistake"))
	logger.LogWarningMessage("Warning about a=%s,%s,%s", "a", "b", "c")
	logger.LogWarning(map[string]interface{}{"a": 4, "b": 5}, errors.Errorf("Cant believe it failed"))
	logger.SQLDebugInfo("SELECT * from user")
	//logger.LogRequestInfo(event)
	//logs.LogSQSEvent(sqsEvent)

	ctx := logger.GetContextLogger()
	ctx.Debugf("Debugging %d!", 456)
	ctx.Infof("Info %d", 789)

	//logs.Errorf("Debugging %d!", 456)
	//logs.Error("Info")
}
